--[[
	format: {name = [Name], type = [Type], subtype = [Subtype], rarity = [Rarity], shop = {[Sold], [Sellable], [Price], [Sell], [Shop Rarity]}, loot = [levelReq], stats = [Stats]}
	
	Any field can be left blank, it will just default.
	
	Name is a string representing the name of the item [Default: "ItemName"]
	Type is the item type, ex. Potion, Weapon, Armor [Default: "None"]
	Subtype is the items sub-type, ex. Mana, Cutlass, Chestplate [Default: "None"]
	Rarity is how often a player might find this item. (This includes shop and loot chances) [Default: "None"]
		This value should be a number 0 - 10. 0 means it will never appear on its own, so use this for quest items. 10 would be a very common item
	Shop Item is a boolean representing if the item can appear in the shop or not 
	Loot is a boolean representing if the item can appear after winning a battle
	Stats is a table representing the values of the item. This is specific to each type
		Potion: {[Effect], [Value]}
			Effect is a string representing the effect of the potion. Ex. "Mana", "Health", "Experience"
			Value represents how much the potion will heal/what value it will have
		Weapon: {[Damage], [Accuracy], [Critical Hit Ratio], [Element], [Effect]}
			Damage is a number representing the base damage of the weapon
			Accuracy is a number representing the base accuracy of the weapon. This should be 0 - 100
			Critical Hit Ratio is a number representing how likely a critical hit is to occur with a successful hit. 0 - 100
			Element is a string representing the element of the weapon. Ex. "Fire", "Wind", "Water", "Electric"
				Only a few special weapons should have elements
			Effect is a string representing a special effect for the item
				In most cases this can be left blank
				Effects: "First-Strike", "Combo-hit" (hit the same enemy multiple times, "Multi-hit" (hit different enemies with the same attact)
		Armor: {[Defense], [Speed], [Effect]}
			Defense is a number representing base damage block
			Speed is a number representing how this item modifies your speed
			Effect is a string representing a special effect for the item
				In most cases this can be left blank
				Effects: (See Weapon Effects)

				]]
				
local items = {
{name = "Wooden Sword", itemType = "weapon", subType = "sword", rarity = "common", shop = {price = 30}, stats = {minDamage = 15, maxDamage = 25}},
{name = "Steel Sword", itemType = "weapon", subType = "sword", rarity = "common", shop = {price = 100}, stats = {minDamage = 30, maxDamage = 45}}
}


return items