
CombatTarget = class("CombatTarget")

function CombatTarget:initialize(entity, x, y, color)
    self.entity = entity
    self.x = x
    self.y = y
    self.img = love.graphics.newImage('img/combat/troll.png')
    self.width = self.img:getWidth()*2
    self.height = self.img:getHeight()*2
    self.color = color or {255, 255, 255}
    self.originalColor = self.color
	
	self.vis = 4
	
	self.shader = love.graphics.newShader('shaders/outline.glsl')
	local width = 1 -- When width is 1, the step size is exactly 1 pixel. 2 will be 2 pixels, etc etc
	self.shader:send("stepSize", {width/self.img:getWidth(), width/self.img:getHeight()})
	self.shader:send("vis", self.vis)
end

function CombatTarget:update(dt)

end

function CombatTarget:mousepressed(key)
	if key == "wu" then
		self.vis = self.vis+1
	elseif key == "wd" then
		self.vis = self.vis-1
	end

end

function CombatTarget:draw()
    if self.entity.health <= 0 then return end
	
    local r, g, b, a = love.graphics.getColor()
    love.graphics.setColor(self.color)
	
	love.graphics.draw(self.img, self.x, self.y, nil, 2, 2)
	
	love.graphics.setShader(self.shader)
    love.graphics.draw(self.img, self.x, self.y, nil, 2, 2)
	love.graphics.setShader()
	
    love.graphics.setColor(r, g, b, a)

    love.graphics.print(self.entity.health, self.x, self.y+self.height)
end


PlayerTarget = class("PlayerTarget", CombatTarget)

function PlayerTarget:initialize(entity, x, y)
    self.entity = entity
    self.x = x
    self.y = y
    self.img = love.graphics.newImage('img/combat/player.png')
    self.idleImg = self.img
    self.attackImg = love.graphics.newImage('img/combat/player_attack.png')
    self.swingImg = love.graphics.newImage('img/combat/player_swing.png')
    self.width = self.img:getWidth()
    self.height = self.img:getHeight()
end

function PlayerTarget:draw()
    if self.entity.health <= 0 then return end

    local color = {love.graphics.getColor()}
    love.graphics.draw(self.img, self.x, self.y)

    love.graphics.print(self.entity.health, self.x, self.y+self.height)
end