Entity = class("Entity")

function Entity:initialize(name)
    self.name = name or "Bob"

    self.maxHealth = 100
    self.health = self.maxHealth

    self.weapon = {
        name = "Iron sword",
        minDamage = 2,
        maxDamage = 4,
        critRange = {19, 20},
    }

    self.armor = {
        name = "Iron armor",
        defense = 3,
    }
end

function Entity:attack(target)
    local dmg = math.random(self.weapon.minDamage, self.weapon.maxDamage)

    -- receiving a critical hit requires you to roll a d20 in your weapon's critical range
    local critRoll = math.random(1, 20)
    local critical = critRoll >= self.weapon.critRange[1] and critRoll <= self.weapon.critRange[2]

    -- if you get a critical hit you receive another damage roll
    if critical then
        dmg = dmg + math.random(self.weapon.minDamage, self.weapon.maxDamage)
    end

    -- deal your weapon damage to target entity
    target.health = target.health - dmg

    return dmg, critical
end