ItemList = class("ItemList")

function ItemList:initialize(dir)
	self.items = {}
	
	local dir = dir or 'data/weapons'
	
	ok, fileList = pcall(love.filesystem.getDirectoryItems, dir, function(fileName)
		if string.find(fileName, 'example') then return end
		local itemProperties = {}
		for line in love.filesystem.lines(dir..'/'..fileName) do
			if string.find(line, 'Name: ') then itemProperties.name = string.gsub(line, 'Name: ', '')
			elseif string.find(line, 'Type: ') then itemProperties.itemType = string.gsub(line, 'Type: ', '')
			elseif string.find(line, 'Subtype: ') then itemProperties.subtype = string.gsub(line, 'Subtype: ', '')
			elseif string.find(line, 'Description: ') then itemProperties.description = string.gsub(line, 'Description: ', '')
			
			elseif string.find(line, 'Shop: ') then itemProperties.shop = string.gsub(line, 'Shop: ', '')
			elseif string.find(line, 'Price: ') then itemProperties.price = string.gsub(line, 'Price: ', '')
			elseif string.find(line, 'Sell: ') then itemProperties.sell = string.gsub(line, 'Sell: ', '')
			elseif string.find(line, 'Shop Rarity: ') then itemProperties.shopRarity = string.gsub(line, 'Shop Rarity: ', '')
			
			elseif string.find(line, 'Loot: ') then itemProperties.loot = string.gsub(line, 'Loot: ', '')
			elseif string.find(line, 'Loot Rarity: ') then itemProperties.lootRarity = string.gsub(line, 'Loot Rarity: ', '')
			
			elseif string.find(line, 'Rarity: ') then itemProperties.rarity = string.gsub(line, 'Rarity: ', '')
			
			elseif string.find(line, 'Damage Min: ') then itemProperties.damageMin = string.gsub(line, 'Damage Min: ', '')
			elseif string.find(line, 'Damage Max: ') then itemProperties.damageMax = string.gsub(line, 'Damage Max: ', '')
			elseif string.find(line, 'Accuracy: ') then itemProperties.accuracy = string.gsub(line, 'Accuracy: ', '')
			elseif string.find(line, 'Crit Min: ') then itemProperties.critMin = string.gsub(line, 'Crit Min: ', '')
			elseif string.find(line, 'Crit Max: ') then itemProperties.critMax = string.gsub(line, 'Crit Max: ', '')
			elseif string.find(line, 'Element: ') then itemProperties.element = string.gsub(line, 'Element: ', '')
			elseif string.find(line, 'Effect: ') then itemProperties.effect = string.gsub(line, 'Effect: ', '')
			
			end
		end
		
		--error(dump(itemProperties))
		local item = Item:new(itemProperties)
		if string.lower(itemProperties.itemType) == 'weapon' then
			item = Weapon:new(itemProperties)
		end
		
		--error(item)
		
		table.insert(self.items, item)
	end)
	--error(dump(self.items))
	
	if not ok then error(fileList) end
end


Item = class("Item")

function Item:initialize(item)
	error("items ARE initialized")
	self.name = item.name or '[No name given]'
	self.rarity = item.rarity or 0
	
	self.shop = item.shop or 'false'
	self.price = item.price or 0
	self.sell = item.sell or 0
	self.shopRarity = item.shopRarity or 0
	
	self.loot = item.loot or 'false'
	self.lootRarity = item.lootRarity or 0
	
	
	self.description = item.description or '-filler description-'
end


Weapon = class("Weapon", Item)

function Weapon:initialize(item)
	Item.initialize(self, item)
	
	self.damageMin = item.damageMin or 0
	self.damageMax = item.damageMax or 0
	self.accuracy = item.accuracy or 0
	self.critMin = item.critMin or 0
	self.critMax = item.critMax or 0
	self.element = item.element or ''
	self.effect = item.effect or ''
end