Bar = class("Bar")

function Bar:initialize(x, y, w, h, m)
    self.x = x
    self.y = y
    self.width = w
    self.height = h
    self.multiplier = m or 1
    self.orientation = "left"

    self.bg = {0, 0, 0, 255}
end

function Bar:draw()
    love.graphics.setColor(self.bg[1], self.bg[2], self.bg[3], self.bg[4])

    if self.orientation == "left" then
        love.graphics.rectangle("fill", self.x, self.y, self.width*self.multiplier, self.height)

    elseif self.orientation == "right" then
        love.graphics.rectangle("fill", self.x-(self.width*self.multiplier)+self.width, self.y, self.width*self.multiplier, self.height)
    end
end

function Bar:setMultiplier(multiplier)
    self.multiplier = multiplier
end

function Bar:orientate(direction)
    if direction == "left" then
        self.orientation = "left"
    end

    if direction == "right" then
        self.orientation = "right"
    end
end

function Bar:align(mode)
    -- this will center align the Bar around the original coordinates
    if mode == 'center' then
        self.x = self.x - self.width/2
        self.y = self.y - self.width/2
    end

    -- this will only align the Bar around the original x coordinate
    if mode == 'center x' then
        self.x = self.x - self.width/2
    end

    -- this will only align the Bar around the original y coordinate
    if mode == 'center y' then
        self.y = self.y - self.width/2
    end
end