EventBox = class('EventBox')

function EventBox:initialize(x, y, w, h)
    self.x = x or love.window.getWidth()/4
    self.y = y or love.window.getWidth()/5
    self.width = w or love.window.getWidth()/2
    self.height = h or 3*love.window.getWidth()/5

    self.margin = 20

    self.frameImage = love.graphics.newImage('img/ui/frame.png')
    self.frameImage:setWrap('repeat', 'repeat')
    self.frameQuad = love.graphics.newQuad(0, 0, love.window.getWidth(), love.window.getHeight(), self.frameImage:getWidth(), self.frameImage:getHeight())

    self.frameVertImage = love.graphics.newImage('img/ui/frame_vert.png')
    self.frameVertImage:setWrap('repeat', 'repeat')
    self.frameVertQuad = love.graphics.newQuad(0, 0, self.frameVertImage:getWidth(), self.frameImage:getHeight(), self.frameVertImage:getWidth(), self.frameVertImage:getHeight())

    self.frameUpperLeft = love.graphics.newImage('img/ui/frame_corner_upper_left.png')
    self.frameUpperRight = love.graphics.newImage('img/ui/frame_corner_upper_right.png')
    self.frameBottomLeft = love.graphics.newImage('img/ui/frame_corner_bottom_left.png')
    self.frameBottomRight = love.graphics.newImage('img/ui/frame_corner_bottom_right.png')
    
    self.frameCornerDiff = 5

    self.frameQuad:setViewport(0, 0, self.boxWidth, self.frameImage:getHeight())
    self.frameVertQuad:setViewport(0, 0, self.frameVertImage:getWidth(), self.boxHeight)
end

function EventBox:draw()
    --[[
    -- background
    love.graphics.setColor(255, 255, 255)
    love.graphics.rectangle("fill", self.boxX, self.boxY, self.boxWidth, self.boxHeight)
    
    -- image frames
    
    -- top and bottom
    love.graphics.draw(self.frameImage, self.frameQuad, self.boxX, self.boxY-self.frameImage:getHeight()/2)
    love.graphics.draw(self.frameImage, self.frameQuad, self.boxX, self.boxY+self.boxHeight-self.frameImage:getHeight()/2)
    -- left and right
    love.graphics.draw(self.frameVertImage, self.frameVertQuad, self.boxX-self.frameVertImage:getWidth()/2, self.boxY)
    love.graphics.draw(self.frameVertImage, self.frameVertQuad, self.boxX+self.boxWidth-self.frameVertImage:getWidth()/2, self.boxY)
    -- corners
    love.graphics.draw(self.frameUpperLeft, self.boxX-self.frameVertImage:getWidth()/2-self.frameCornerDif, self.boxY-self.frameVertImage:getWidth()/2-self.frameCornerDif)
    love.graphics.draw(self.frameUpperRight, self.boxX+self.boxWidth-self.frameVertImage:getWidth()/2, self.boxY-self.frameVertImage:getWidth()/2-self.frameCornerDif)
    love.graphics.draw(self.frameBottomLeft, self.boxX-self.frameVertImage:getWidth()/2-self.frameCornerDif, self.boxY+self.boxHeight-self.frameVertImage:getWidth()/2)
    love.graphics.draw(self.frameBottomRight, self.boxX+self.boxWidth-self.frameVertImage:getWidth()/2, self.boxY+self.boxHeight-self.frameVertImage:getWidth()/2)

    love.graphics.setColor(0, 0, 0)
    local msg = self.current.actions[self.currentStep].msg
    local msgHeight = font[32]:getHeight(msg)
    
    love.graphics.printf(msg, self.boxX + self.boxMargin, self.boxY + self.boxMargin, self.boxWidth - self.boxMargin * 2, "left")
    

    love.graphics.print("z to continue", self.boxX + self.boxMargin, self.boxY + self.boxHeight - self.boxMargin - msgHeight)
    ]]
end