death = {}

death.uiElements = {}

function death:init()
    self.backgroundImage = love.graphics.newImage('img/bg/sand_papyrus.jpg')

    self.continueButton = Button("Continue", love.graphics.getWidth()/2, 700)
    self.continueButton:align('x')
    self.continueButton:setFG(255, 255, 255)
    self.continueButton:setBG(0, 0, 0, 0)
    self.continueButton:setFont(font[36])
    self.continueButton.activated = function()
        fx.transition(0.35, game)
    end
    table.insert(self.uiElements, self.continueButton)

    self.selector = Selector:new(self.uiElements)
end

function death:leave()
    game.player:revive(self.goldLost)
end

function death:update(dt)
    self.goldLost = math.floor(game.player.gold/2)
    self.selector:update(dt)
end

function death:keypressed(key, isrepeat)
    self.selector:keypressed(key, isrepeat)
end

function death:draw()
    -- background image for top and bottom bars
    local sx = love.graphics.getWidth()/self.backgroundImage:getWidth()
    local sy = love.graphics.getHeight()/self.backgroundImage:getHeight()
    love.graphics.draw(self.backgroundImage, 0, 0, nil, sx, sy)

    -- victory text
    local text = "DEFEAT"
    love.graphics.setFont(font[56])
    love.graphics.print(text, love.graphics.getWidth()/2 - love.graphics.getFont():getWidth(text)/2, 75)

    local text = "Lost "..tostring(self.goldLost)..' gold.'
    love.graphics.setFont(font[32])
    love.graphics.print(text, love.graphics.getWidth()/2 - love.graphics.getFont():getWidth(text)/2, 300)

    local text = "You have been revived at the last town you visited."
    love.graphics.setFont(font[24])
    love.graphics.print(text, love.graphics.getWidth()/2 - love.graphics.getFont():getWidth(text)/2, 350)


    self.continueButton:draw()
    
    self.selector:draw()

    fx.draw()
end