event = {}


function event:init()
	self.events = require 'data.events'
	
	local windowWidth, windowHeight = love.graphics.getDimensions()
	self.boxX = windowWidth/4
	self.boxY = windowHeight/5
	self.boxWidth = windowWidth/2
	self.boxHeight = windowHeight*3/5
	
	self.boxMargin = 20

    self.frameImage = love.graphics.newImage('img/ui/frame.png')
    self.frameImage:setWrap('repeat', 'repeat')
    self.frameQuad = love.graphics.newQuad(0, 0, love.graphics.getWidth(), love.graphics.getHeight(), self.frameImage:getWidth(), self.frameImage:getHeight())

    self.frameVertImage = love.graphics.newImage('img/ui/frame_vert.png')
    self.frameVertImage:setWrap('repeat', 'repeat')
    self.frameVertQuad = love.graphics.newQuad(0, 0, self.frameVertImage:getWidth(), self.frameImage:getHeight(), self.frameVertImage:getWidth(), self.frameVertImage:getHeight())

    self.frameUpperLeft = love.graphics.newImage('img/ui/frame_corner_upper_left.png')
    self.frameUpperRight = love.graphics.newImage('img/ui/frame_corner_upper_right.png')
    self.frameBottomLeft = love.graphics.newImage('img/ui/frame_corner_bottom_left.png')
    self.frameBottomRight = love.graphics.newImage('img/ui/frame_corner_bottom_right.png')
	
	self.frameCornerDif = 5

    self.frameQuad:setViewport(0, 0, self.boxWidth, self.frameImage:getHeight())
    self.frameVertQuad:setViewport(0, 0, self.frameVertImage:getWidth(), self.boxHeight)
end

function event:enter()
	local eventNum = 1
	local theEvent = self.events[1]
	
	self.current = theEvent
	self.currentSteps = #self.current.actions
	self.currentStep = 1
end

function event:check(step)
	if self.current.actions[self.currentStep].gift then
		local gift = self.current.actions[self.currentStep].gift
		if gift.gtype == "gold" then
			local amt = math.random(gift.minAmt, gift.maxAmt)
			game.player:modifyInv("gold", "give", amt)
		end
	end
	
	if self.current.actions[self.currentStep].result then
		local result = self.current.actions[self.currentStep].result
		if result == "combat" then
			state.pop()
		end
	end
	
	--if self.current.options[self.currentStep
	
	if step and self.current.actions[self.currentStep].goto then
		event:gotoTagInCurrent(tag)
	end
end

function event:gotoTagInCurrent(tag)
	for i = 1, #self.current.actions do
		if self.current.actions[i].tag == self.current.actions[self.currentStep].goto then
			self.currentStep = i
			break
		end
	end
end

function event:option(num)
	local results = self.current.actions[self.currentStep].options[num].result
	local chanceCounter = 0
	
	for i = 1, #results do
		chanceCounter = chanceCounter + results[1].chance
	end
	
	local randomNum = love.math.random(chanceCounter)
	
	--for i = 1, #results do
	local i = 1
		--if randomNum <= results[i].chance then
			for j = 1, #self.current.actions do
				if self.current.actions[j].tag == self.current.actions[self.currentStep].goto then
					self.currentStep = j
					break
				end
			end
		--end
	--end
end

function event:keypressed(key)
	if key == "z" then
		if self.currentStep < self.currentSteps then
			event:check(true)
		else
			event:check()
		end
	elseif key == "1" or key == "2" or key == "3" then
		--event:option(tonumber(key))
	end
end

function event:draw()
	combat:draw()

	if self.current then
		-- background
		love.graphics.setColor(255, 255, 255)
		love.graphics.rectangle("fill", self.boxX, self.boxY, self.boxWidth, self.boxHeight)
		
		-- image frames
		
		-- top and bottom
		love.graphics.draw(self.frameImage, self.frameQuad, self.boxX, self.boxY-self.frameImage:getHeight()/2)
		love.graphics.draw(self.frameImage, self.frameQuad, self.boxX, self.boxY+self.boxHeight-self.frameImage:getHeight()/2)
		-- left and right
		love.graphics.draw(self.frameVertImage, self.frameVertQuad, self.boxX-self.frameVertImage:getWidth()/2, self.boxY)
		love.graphics.draw(self.frameVertImage, self.frameVertQuad, self.boxX+self.boxWidth-self.frameVertImage:getWidth()/2, self.boxY)
		-- corners
		love.graphics.draw(self.frameUpperLeft, self.boxX-self.frameVertImage:getWidth()/2-self.frameCornerDif, self.boxY-self.frameVertImage:getWidth()/2-self.frameCornerDif)
		love.graphics.draw(self.frameUpperRight, self.boxX+self.boxWidth-self.frameVertImage:getWidth()/2, self.boxY-self.frameVertImage:getWidth()/2-self.frameCornerDif)
		love.graphics.draw(self.frameBottomLeft, self.boxX-self.frameVertImage:getWidth()/2-self.frameCornerDif, self.boxY+self.boxHeight-self.frameVertImage:getWidth()/2)
		love.graphics.draw(self.frameBottomRight, self.boxX+self.boxWidth-self.frameVertImage:getWidth()/2, self.boxY+self.boxHeight-self.frameVertImage:getWidth()/2)

		love.graphics.setColor(0, 0, 0)
		local msg = self.current.actions[self.currentStep].msg
		local msgHeight = font[32]:getHeight(msg)
		
		love.graphics.printf(msg, self.boxX + self.boxMargin, self.boxY + self.boxMargin, self.boxWidth - self.boxMargin * 2, "left")
		
		--if self.current.actions[self.currentStep].options then
		--	for k, option in ipairs(self.current.actions[self.currentStep].options) do
		--		love.graphics.print(option.msg, self.boxX + self.boxMargin, self.boxY + self.boxHeight - self.boxMargin - msgHeight*4 + msgHeight*k)
		--	end
		--else
			love.graphics.print("z to continue", self.boxX + self.boxMargin, self.boxY + self.boxHeight - self.boxMargin - msgHeight)
		--end
	end
end
