pause = {}

pause.uiElements = {}

function pause:init()
    self.panelWidth = 300
    self.panelHeight = 500
    self.panelX = love.graphics.getWidth()/2 - self.panelWidth/2
    self.panelY = love.graphics.getHeight()/2 - self.panelHeight/2
	
	self.panelImg = love.graphics.newImage('img/ui/pauseMenu.png')
	self.panelImgX = love.graphics.getWidth()/2 - self.panelImg:getWidth()/2
	self.panelImgY = self.panelY - 60
	
    self.resume = Button:new("Resume game", self.panelX+20, self.panelY+20, self.panelWidth-40, 100)
    self.resume:setFG(0, 0, 0)
    self.resume.activated = function() state.pop() end
    table.insert(self.uiElements, self.resume)

    self.saveQuit = Button:new("Save and Quit", self.panelX+20, self.panelY+130, self.panelWidth-40, 100)
    self.saveQuit:setFG(0, 0, 0)
    self.saveQuit.activated = function() 
        fx.transition(0.35, save)
        self.savingAndQuitting = true
    end
    table.insert(self.uiElements, self.saveQuit)
    self.savingAndQuitting = false

    self.selector = Selector:new(self.uiElements)
    self.selector.orientation = "vertical"
end

function pause:enter()
    self.savingAndQuitting = false
end

function pause:update(dt)
    self.selector:update(dt)
end

function pause:keypressed(key, isrepeat)
    if key == "escape" or key == "x" then
        state.pop()
    end

    self.selector:keypressed(key, isrepeat)
end

function pause:draw()
    game:draw()

    love.graphics.setColor(255, 255, 255)
    --love.graphics.rectangle("fill", self.panelX, self.panelY, self.panelWidth, self.panelHeight)
	love.graphics.draw(self.panelImg, self.panelImgX, self.panelImgY)
	
    self.resume:draw()
    self.saveQuit:draw()

    self.selector:draw()

    fx.draw()
end