start = {}

start.uiElements = {}

function start:init()
    self.backgroundImage = love.graphics.newImage('img/bg/sand_papyrus.jpg')

    self.scrollImage = love.graphics.newImage('img/bg/scroll.png')
    self.scrollShadowImage = love.graphics.newImage('img/bg/scroll_shadow.png')

    self.continueButton = Button("Continue", love.graphics.getWidth()/2, 600)
    self.continueButton:setFont(font[36])
    self.continueButton:align('x')
    self.continueButton:setFG(255, 255, 255)
    self.continueButton:setBG(0, 0, 0, 0)
    self.continueButton.activated = function() self:continue() end

    love.keyboard.setKeyRepeat(true)

    local width = 450
    local x = love.graphics.getWidth()/2 - width/2
    self.nameInput = Input:new(x, 200, 450, 80, "center")

    table.insert(self.uiElements, self.nameInput)
    table.insert(self.uiElements, self.continueButton)

    self.selector = Selector:new(self.uiElements, 1)
    self.nameInput.selected = true
end

function start:update(dt)
    self.selector:update(dt)
end

function start:enter()
    love.graphics.setBackgroundColor(22, 22, 22)

    self.nameInput.text = ""
    self.nameInput.selected = ""
end

function start:continue()
	local nameOk = string.len(self.nameInput.text) >= 1

	if nameOk then
        game.player = Player:new(self.nameInput.text)
		game:genMap()

		fx.transition(0.35, game)
	end
end

function start:keypressed(key, isrepeat)
    self.nameInput:keypressed(key, isrepeat)
    self.selector:keypressed(key, isrepeat)

    if key == "escape" then
        fx.transition(0.35, menu)
    end
end

function start:textinput(text)
    self.nameInput:textinput(text)
end

function start:draw()
    love.graphics.setColor(255, 255, 255)

    -- background image for top and bottom bars
    local sx = love.graphics.getWidth()/self.backgroundImage:getWidth()
    local sy = love.graphics.getHeight()/self.backgroundImage:getHeight()
    love.graphics.draw(self.backgroundImage, 0, 0, nil, sx, sy)

    -- scroll shadow
    local x = love.graphics.getWidth()/2 - self.scrollShadowImage:getWidth()/2
    local y = 0
    love.graphics.draw(self.scrollShadowImage, x, 83)

    -- scroll
    local x = love.graphics.getWidth()/2 - self.scrollImage:getWidth()/2
    local y = 0
    love.graphics.draw(self.scrollImage, x, 100)

    self.continueButton:draw()
    self.nameInput:draw()

    self.selector:draw()

    fx.draw()
end