tavern = {}

tavern.sound = {}
tavern.buttons = {}

tavern.lines = require 'data.lines'

TavernButton = class("TavernButton", Button)
-- http://fc06.deviantart.net/fs70/i/2013/235/1/b/_left_hook__tavern_by_takeda11-d3iivms.jpg
function TavernButton:initialize(text, x, y, w, h)
    Button.initialize(self, text, x, y, w, h)

    self:setFont(font[32])
    self:align("y")
    self:setBG(22, 22, 22, 0)
    self:setFG(255, 255, 255)
    table.insert(tavern.buttons, self)
end

function tavern:init()
	--self.sound.theme = love.audio.newSource('sound/townTheme.mp3', 'stream')
    --self.sound.themeVolume = 0.0

    --love.graphics.setBackgroundColor(33, 33, 33)

    --playSound(self.sound.theme, self.sound.themeVolume)

    --self.banner = love.graphics.newImage('img/bg/town.jpg')
    --self.backgroundImage = love.graphics.newImage('img/bg/papyrus.jpg')

    -- baseline to place buttons on
    --self.buttonLine = love.graphics.getHeight() - (love.graphics.getHeight() - self.banner:getHeight())/4
	self.buttonLine = love.graphics.getHeight() - 100
	
    -- baseline to put frame on
    --self.frameLine = (love.graphics.getHeight() - self.banner:getHeight())/2

    --self.margin = 75

    self.buttonsWidth = function()
        local sum = 0
        for k, button in pairs(self.buttons) do
            sum = sum + button.width
        end

        return ((#self.buttons)*self.margin) + sum
    end

    --self.innButton = TownButton("Tavern", 0, self.buttonLine)
    --self.storeButton = TownButton("Shoppe", self.buttonsWidth(), self.buttonLine)
    --self.squareButton = TownButton("Town Square", self.buttonsWidth(), self.buttonLine)
    --self.quitButton = TownButton("Leave", self.buttonsWidth(), self.buttonLine)

	self.buttons = {}
	
    -- center buttons around center of the screen
    for k, button in pairs(self.buttons) do
        button.x = button.x + love.graphics.getWidth()/2 - self.buttonsWidth()/2 + self.margin/2
    end

    --self.frameImage = love.graphics.newImage('img/ui/frame.png')
    --self.frameImage:setWrap('repeat', 'repeat')
    --self.frameQuad = love.graphics.newQuad(0, 0, love.graphics.getWidth(), self.frameImage:getHeight(), self.frameImage:getWidth(), self.frameImage:getHeight())
	
	local windowWidth, windowHeight = love.graphics.getWidth(), love.graphics.getHeight()
	local textMaxWidth = 500
	
	self.currentLine = 0
	tavern:nextLine()
end

function tavern:nextLine(buttonPressed)
	if self.currentLine == 0 then
		self.currentLine = self.currentLine + 1
	elseif buttonPressed then
		local option = tavern.lines.tavern[self.currentLine].options[buttonPressed]
	
		local action = option.action
		if type(action) == "number" then
			self.currentLine = action
		elseif type(action) == "string" then
			if action == "next" then
				self.currentLine = self.currentLine + 1
			elseif action == "heal" then
				game.player.health = game.player.maxHealth
				self.currentLine = self.currentLine + 1
			elseif action == "leave" then
				texter:removeTagged("story")
				self.buttons = {}
				state.switch(town)
			else
			--[[
				for k, v in pairs(tavern.lines.tavern) do
					if v.name == action then
						self.currentLine = action
						break
					end
				end
				]]
			end
		end
	end
	
	--texter:clear()
	texter:removeTagged("story")
	
	local windowWidth, windowHeight = love.graphics.getWidth(), love.graphics.getHeight()
	local textMaxWidth = 500
	
	local line = tavern.lines.tavern[self.currentLine].text
	
	
	local townName = "Guilder"
	
	--line = string.gsub(line, "$PlayerName", game.player.name)
	--line = string.gsub(line, "$TownName", townName)
	
	--texter:add("Welcome to the "..townName.." Tavern, friend, what can I do for ya'?", 200-20, 200, {255, 255, 255}, 500+20, "center", 0)
	texter:add(line, windowWidth/2-textMaxWidth/2, windowHeight/2-50, {100, 255, 255}, 500, "center", 0, "story")
	
	----
	self.buttons = {}
	
	local options = tavern.lines.tavern[self.currentLine].options
	for k, v in pairs(options) do
		--table.insert(self.buttons, TavernButton(v.text, (windowWidth/#options)*k-(windowWidth/#options)/2-font[18]:getWidth(v.text)/2, self.buttonLine))
		table.insert(self.buttons, TavernButton(v.text, 200 * k, self.buttonLine))
	end
	
	--if options[2] then
		--table.insert(self.buttons, TavernButton(options[2].text, 200 * 2, self.buttonLine))
	--end
end

function tavern:mousepressed(x, y, button)
	-- added these 3 lines in to avoid a bug
	texter:removeTagged("story")
	self.buttons = {}
	state.switch(town)
	--

    --if self.quitButton:clicked() then
    --    state.switch(game)
    --end
	for k, button in ipairs(self.buttons) do
		if button:hover() then
			tavern:nextLine(k)
			break
		end
	end
end

function tavern:keypressed(key, isrepeat)
	-- added these 3 lines in to avoid a bug
	texter:removeTagged("story")
	self.buttons = {}
	state.switch(town)
	--
	
	if key == " " then
		if self.currentLine < #tavern.lines.tavern then
			tavern:nextLine(1)
		else
			--tavern:nextLine()
			--texter:removeTagged("story")
			--state.switch(town)
		end
	end
end

function tavern:update(dt)
	texter:update(dt)
end

function tavern:draw()

	-- background image
   -- local sx = love.graphics.getWidth()/self.backgroundImage:getWidth()
   -- local sy = love.graphics.getHeight()/self.backgroundImage:getHeight()
   -- love.graphics.draw(self.backgroundImage, 0, 0, nil, sx, sy)

    -- banner image
    love.graphics.setColor(255, 255, 255)
   -- local x = 0
  --  local y = (love.graphics.getHeight() - self.banner:getHeight())/2
   -- love.graphics.draw(self.banner, x, y)

    -- title text
   -- local text = "Hello, welcome to NuthIkroth-ville!"
    love.graphics.setFont(font[48])

    -- outline
   -- love.graphics.setColor(0, 0, 0)
   -- love.graphics.print(text, 52, 42)

    -- main text
   -- love.graphics.setColor(255, 255, 255)
   -- love.graphics.print(text, 50, 40)

    -- image frames
   -- love.graphics.draw(self.frameImage, self.frameQuad, 0, self.frameLine-self.frameImage:getHeight()/2)
   -- love.graphics.draw(self.frameImage, self.frameQuad, 0, love.graphics.getHeight()-self.frameLine-self.frameImage:getHeight()/2)

    -- buttons
   -- self.innButton:draw()
    --self.storeButton:draw()
    --self.squareButton:draw()
    --self.quitButton:draw()

	
	--text:drawStuff()
	texter:draw()
	for k, v in pairs(self.buttons) do
		v:draw()
	end
	
    fx.draw()
end